from agent import Agent
import random

class AgentApprox(Agent):
    def __init__(self, name, initial_num_pieces, alpha=0.7, gamma=0.2, epsilon=1.0):
        Agent.__init__(self, name, initial_num_pieces)

        self.epsilon = epsilon
        self._explore_mode = True
        self.alpha = alpha
        self.gamma = gamma

        self.features = {
                            # TODO: Fill in some other useful features here!
                            # x is a tuple of the form (state, action)
                            "example": (lambda x: x[0])
                        }
        self.weights = {k : 0 for k in self.features}

        self.last_state = None
        self.last_action = None
    
    def getValue(self, state, action):
        # TODO: Fill me in!
        return 0

    def updateWeights(self, state, action, reward=0):
        successor = state - action
        for feature in self.weights:
            # TODO: Fill me in!
            

    def getAction(self, state):
        if self.last_state and self.last_action:
            self.updateWeights(self.last_state, self.last_action)
        if self._explore_mode == True and random.random() < self.epsilon:
            action = random.randrange(1, 3)
        else:
            action = 1 if self.getValue(state, 1) > self.getValue(state, 2) else 2
        action = min(action, state)
        
        self.last_state = state
        self.last_action = action
        return action
    
    def win(self):
        super().win()
        self.updateWeights(self.last_state, self.last_action, 10)
            
    def lose(self):
        super().lose()
        self.updateWeights(self.last_state, self.last_action, -10)
    
    @property
    def explore_mode(self):
        return self._explore_mode
        
    @explore_mode.setter
    def explore_mode(self, explore_mode):
        self._explore_mode = explore_mode

    def print_stats(self):
        super().print_stats()

        agent_string = "\t{} Statistics\n".format(self.name)

        agent_string += str(self.weights)

        print(agent_string)